/********************************************
Copyright Pavel Potapov, 2013-2016
distributed under GNU General Public License
********************************************/


/***********************CHECK********************************/

if(doesfunctionexist("pastewidth112"))
	{
	result("\nfunctions "+"ImagePaste112 "+" already installed\n");
	throw("")
	}	
result("\ninstall functions "+"ImagePaste112")

/************************************************
Function: find overlap width
************************************************/	
number PasteWidth112(number WidthDest,number Widthsource)
	{
	number Width = min(WidthDest,Widthsource)
	
	return Width 
	
	//Then paste e.g. 
	//left: destination[0,0,1,Width] = source[0,0,1,Width] 
	//right: destination[0,WidthDest-Width,1,WidthDest] = source[0,Widthsource-Width,1,Widthsource]
	}

/************************************************
Function: find parameters to past image with shift
************************************************/
void PasteShiftedLimits112(number &leftD,number &leftS,number &Width,number shift,number WidthD,number WidthS)
	{
	if(shift<0) 
		{
		leftD = 0
		leftS = round(-shift)
		Width = min(WidthS-leftS,WidthD)
		}
	else
		{
		leftD = round(shift)
		leftS = 0
		Width = min(WidthS,WidthD-leftD)		
		}	
		
	//then paste for instance as:
	//destination[0,leftD,1,leftD + Width] = source[0,leftS,1,leftS +Width]
	}

/************************************************
Function: paste source image into destination without carrying of size
	(left-upper corners counside))
************************************************/
void PasteImage112(image source,image destination)
	{
	number widthS,HeightS,widthD,HeightD
	source.getSize(widthS,HeightS)
	destination.getSize(widthD,HeightD)

	number Width = PasteWidth112(WidthD,WidthS)
	number Height = PasteWidth112(HeightD,HeightS)

	destination[0,0,Height,Width] = source[0,0,Height,Width]
	}

/************************************************
Function: paste source image into destination with a given X,Y shifts
		without carrying of size	
************************************************/
void PasteShifted112(image source,image destination,number shiftX,number shiftY)
	{
	number WidthS,HeightS,WidthD,HeightD
	source.getSize(WidthS,HeightS)
	destination.getSize(WidthD,HeightD)

	number topD,leftD,topS,leftS,width,height	
	PasteShiftedLimits112(leftD,leftS,width,shiftX,WidthD,WidthS)
	PasteShiftedLimits112(topD,topS,height,shiftY,HeightD,HeightS)
	
	destination[topD,leftD,topD+height,leftD+Width] = source[topS,leftS,topS+height,leftS+Width]
	}

/************************************************
Function: truncate coordinate to be inside range
************************************************/
number SqueezeToWidth112(number x,number width)
	{
	if(x<0) return 0
	if(x>=width) return (width-1)
	return round(x)
	}

/************************************************
Function: truncate X,Y coordinates to be inside image
************************************************/
void SqueezeToImage112(number &x,number &y,image im)
	{
	number Width,Height
	im.getSize(Width,Height)
	
	x = SqueezeToWidth112(x,Width)
	y = SqueezeToWidth112(y,Height)
	}

/************************************************
Function: build 3D image with its type code
************************************************/
image Make2DImageOfRightType112(number type,string Name,number W,number H)
{
image out

if(type==14)out := binaryimage(Name,1,W,H)

if(type==2) out := realimage(Name,4,W,H)
if(type==12)out := realimage(Name,8,W,H)

if(type==3) out := compleximage(Name,8,W,H)
if(type==13)out := compleximage(Name,16,W,H)

if(type==9) out := integerimage(Name,1,1,W,H)
if(type==6) out := integerimage(Name,1,0,W,H)
if(type==1) out := integerimage(Name,2,1,W,H)
if(type==10)out := integerimage(Name,2,0,W,H)
if(type==7) out := integerimage(Name,4,1,W,H)
if(type==11)out := integerimage(Name,4,0,W,H)
if(type==39)out := integerimage(Name,8,1,W,H)
if(type==40)out := integerimage(Name,8,0,W,H)

return out
}

/************************************************
Function: build 3D image with its type code
************************************************/
image Make3DImageOfRightType112(number type,string Name,number W,number H,number D)
{
image out

if(type==14)out := binaryimage(Name,1,W,H,D)

if(type==2) out := realimage(Name,4,W,H,D)
if(type==12)out := realimage(Name,8,W,H,D)

if(type==3) out := compleximage(Name,8,W,H,D)
if(type==13)out := compleximage(Name,16,W,H,D)

if(type==9) out := integerimage(Name,1,1,W,H,D)
if(type==6) out := integerimage(Name,1,0,W,H,D)
if(type==1) out := integerimage(Name,2,1,W,H,D)
if(type==10)out := integerimage(Name,2,0,W,H,D)
if(type==7) out := integerimage(Name,4,1,W,H,D)
if(type==11)out := integerimage(Name,4,0,W,H,D)
if(type==39)out := integerimage(Name,8,1,W,H,D)
if(type==40)out := integerimage(Name,8,0,W,H,D)

return out
}


/************************************************
Function: copy arbitrary ROI from image (any(even negative) 
	but top<bottom,left<right frame is allowed)
************************************************/
image SelectArea112(image source,number top,number left,number bottom,number right)
	{ 
	number Width,Height
	source.getSize(Width,Height)
	
	number type = source.ImageGetDataType()
	image destination = Make2DImageOfRightType112(type,"",right-left,bottom-top)
	
	number overlap = 1
	
	number leftS = SqueezeToWidth112(left,Width)
	number rightS = SqueezeToWidth112(right,Width)
	number topS = SqueezeToWidth112(top,Height)
	number bottomS = SqueezeToWidth112(bottom,Height)
	
	number WidthS = rightS-leftS
	number HeightS = bottomS-topS
	
	number leftD = max(leftS - left,0)
	number rightD = leftD + WidthS
	number topD = max(topS - top,0)
	number bottomD = topD + HeightS
	
	if((WidthS>0)&&(HeightS>0))
		{
		destination[topD,leftD,bottomD,rightD] = source[topS,leftS,bottomS,rightS]
		}
		
	return destination	
	}
	
/*
number w1=101
number h1=98
number w2 = 98
number h2 = 101

image im1 := realimage("",4,w1,h1)	
image im2 := realimage("",4,w2,h2)
im1 = cos(icol)
im2 = cos(irow)
//im1.showimage()

//PasteImage112(im1,im2)
number shiftX = -10.2
number ShiftY = -11.5
//PasteShifted112(im1,im2,shiftX,shiftY)
//im2.showimage()

number top = 20
number bottom = 120
number left = 20
number right = 100
image im3 = SelectArea112(im1,top,left,bottom,right)
im3.showimage()
*/