
/********************************************
Copyright Pavel Potapov, 2013-2016
distributed under GNU General Public License
********************************************/

if(!doesclassexist("uiframe112"))
	{
	throw("package Timer require installation of extended frames classes")
	}

Interface TimerInterface
{
void NewDLGFrame(object starter);
void TimeClick( object event_source, number event_flag, object listener,number i);    
void TimeClick( object event_source, number event_flag, object listener);   
}



/******************************************************************
BACKGROUND ADAPTER                                  
******************************************************************/
class BackgroundAdapter112: UIFrame112
{
TagGroup Square
number Value
image test

image refresh(object self,number Value)
	{
	test = Value
	return test
	}
	
TagGroup CreateUpDownPanel(object self,number size,number bcgr,number Rahm)
	{	
	TagGroup UpDown = DLGCreateDialog("").DLGTableLayout(2,1,1)	

	UpDown.DLGAddElement(self.Button112(self.Iarrow(1,size,bcgr,Rahm),"Plus"))		
	UpDown.DLGAddElement(self.Button112(self.Iarrow(3,size,bcgr,Rahm),"Menus"))

	return UpDown
	}
	
TagGroup CreatePanel(object self,string Label,number ValueP)
	{
	Value = valueP
	number size=80
	test:=integerImage("",1,0,size,size)
	
	TagGroup Panel = DLGCreateBox("background adapter")//.DLGTableLayout(2,2,0)
	Panel.DLGAddElement(DLGCreateLabel("make square invisible:"))
		Square = DLGCreateGraphic(size,size).DLGAddBitmap(self.refresh(Value))
	Panel.DLGAddElement(Square.DLGExternalPadding(30,5))
	Panel.DLGAddElement(self.CreateUpDownPanel(size*0.3,210,size*0.1))
	
	return Panel
	}

void Change(object self,number Increment)
	{
	Value += Increment
result("\nbackground "+value)
	Square.DLGGetElement(0).DLGBitmapData(self.refresh(Value))	
	}
	
void Plus(object self) self.Change(1)
void Menus(object self) self.Change(-1)

//No need to do full initiation of UIFrame112
void init (object self,string lab)
	{
	//only set package and frame names
	self.SetPackageName(lab) 	//this may be used for all scripts in family "lab"
								//thus set "lab" instead of "lab:Timer"
	self.SetFrameName("BackgroundAdapter")
	
	//load stored background value
	Value = self.LoadNumber112(210,"background")
	 
	//standard pose dialog (not UIFrame112 initialisation)
	self.init( self.CreatePanel("",Value) );
	if(Pose(self)) self.StoreNumber112(Value,"background")

	}
}


/******************************************************************
TIMER
******************************************************************/	
class Timer112 :UIFrame112
{
//numbers controlling Timer display (kept as global to speed display up
number size,Bcgrd
number countSec,countDays 
number TargetD,TargetH,TargetM,TargetS	//target time in days,hours,min,sec	
string Message
//names of global (needed for storage and loading)
string DaysName,HoursName,MinName,SecName,MessageName,CountDaysName,CountSecName,SizeName
//numbers dependent on the global
number Width,Height,Between,TotWidth	//display size
number MaxTime			//target time (calculated from input days,hours,min,sec)

image digitBank	//drawings of all digits
image delim		//drawing of deliminator
image Tableau	//drawing of actual time tableau

image Counts			//keep actual time counts in array 
number Tick0,TickP,t,tP	//time marks
number Period			//period for updating Timer 
number running,paused	//flags for thread 



image DrawDigit(object self,number in)
	{
	return self.GraphicFromString(""+in,size,"",1,Bcgrd)
	}

image DrawMessage(object self)
	{
	image fullMessage = self.GraphicFromString(Message,size,"",1,Bcgrd)
	
	image ClippedMessage := integerimage("",1,0,TotWidth,Height)
	ClippedMessage = Bcgrd
	
	PasteImage112(fullMessage,ClippedMessage)
	number top,left,bottom,right
	
	return ClippedMessage
	}

void setDigitInTableau (object self,image &givenTableau, number pos,number i)
	{
	number left = pos*width
	if(pos>=2) left += Between
	if(pos>=4) left += Between
	if(pos>=6) left += Between
	
	number right = left + Width
//result("\nleft "+left+" right "+right)	
	givenTableau[0,left,Height,right] = digitBank[0,0,i,Width,Height,i+1]
	}

void setPointsInTableau (object self,image &givenTableau,number pos)
	{
	number left = 2*width
	if(pos>=1) left += (2*width+Between)
	if(pos>=2) left += (2*width+Between)
	
	number right = left + Between
	
	givenTableau[0,left,Height,right] = delim
	}

image DrawTableau(object self)
	{
	image givenTableau := integerimage("",1,0,TotWidth,Height)
	
	self.setPointsInTableau(givenTableau,0)
	if(CountDays) self.setPointsInTableau(givenTableau,CountDays)
	if(CountSec) self.setPointsInTableau(givenTableau,CountDays+CountSec)
	
	return givenTableau
	}
	
void updateRegister(object self,image &givenTableau,number register,number base,number &time)
	{
	number digit = trunc(time/base)
	time -= digit*base
	
	try{
		if(digit != Counts.getPixel(register,0))
			{
			Counts.SetPixel(register,0,digit)
			self.setDigitInTableau(givenTableau,register,digit)	
			}
		}
	catch{break;}	
	}
		
void updateTableau(object self,image &givenTableau,number t)
	{
	if(CountDays)
		{
		self.updateRegister(givenTableau,0,864000,t)
		self.updateRegister(givenTableau,1,86400,t)
		}
	else if(t>86400) t=86400 //discard time that cannot be displayed
	
	number shift = 2*CountDays	
	
	self.updateRegister(givenTableau,0+shift,36000,t)
	self.updateRegister(givenTableau,1+shift,3600,t)
	self.updateRegister(givenTableau,2+shift,600,t)
	self.updateRegister(givenTableau,3+shift,60,t)
	
	if(CountSec) self.updateRegister(givenTableau,4+shift,10,t)
	if(CountSec) self.updateRegister(givenTableau,5+shift,1,t)			
	}

void UpdateMaxTime(object self)
	{
	MaxTime = TargetD*86400 + TargetH*3600 + TargetM*60 + TargetS
	}

void Pause(object self)
	{
	if(running)
		{
		paused = 1
		TickP = GetHighResTickCount() //timeTick when paused
		}
	}

void releasePause(object self)
	{
	if(running)
		{
		paused = 0	
		tP += CalcHighResSecondsBetween(TickP,GetHighResTickCount()) //count paused seconds
		}
	}	
	
//DLG tags
TagGroup DLGtags(object self)
	{
	//target Tableau
	image TargetTableau = self.DrawTableau() 
	self.updateTableau(TargetTableau,MaxTime)
	TagGroup TargetTableauT = DLGAddBitmap(DLGCreateGraphic(TotWidth,Height),TargetTableau)
	
	//counting Tableau		
	TagGroup TableauT = DLGAddBitmap(DLGCreateGraphic(TotWidth,Height),Tableau).DLGIdentifier("Tableau")
	
	//Box with buttons
	TagGroup PlayBox = DLGCreateBox("")
	PlayBox.DLGTableLayout(5+4*(countDays+CountSec),1,0).DLGAnchor("West")
	
		image On = self.Ipause(size,Bcgrd,0.1*size)
		image Off= self.Iplay(size,Bcgrd,0.1*size)
	PlayBox.DLGAddElement(DLGCreateDualStateBevelButton("PlayState",On.DLGMakeLowered(),Off.DLGMakeraised(),"ClickPlay"))
	for(number i=0;i<=2*(countDays+CountSec);i++)PlayBox.DLGAddElement(DLGcreateLabel(""))
		image Cenab = self.GraphicFromString("C",0.8*size,"",1,Bcgrd)
		image Cdisab = 0.4*Cenab + 0.6*Bcgrd
	PlayBox.DLGAddElement(DLGCreateDualStateBevelButton("ResetState",Cdisab.DLGMakeraised(),Cenab.DLGMakeraised(),"reset"))	
	for(number i=0;i<=2*(countDays+CountSec);i++)PlayBox.DLGAddElement(DLGcreateLabel(""))
	PlayBox.DLGAddElement(self.settingsButton(1.15*size,Bcgrd,"Settings"))

	TagGroup Dialog = DLGCreateDialog("")
	Dialog.DLGAddElement(TargetTableauT)
	Dialog.DLGAddElement(TableauT)
	Dialog.DLGAddElement(PlayBox)	
 
	return Dialog
	}

//The essential part of the redrawing UIFrames
//this methodName is STANDARD and interfaced (not change the name)
//This method can be call either from "init" or from "Redrawer" object	
void RedrawnUIFrame112(object self) 
	{
	self.initUIFrame112(self.DLGtags(),self.GetPackageName(),self.GetFrameName())

	if((paused==1)&&(running==0)) //timer was running before redrawn
		{
		running = 1;	//restore running (it was nullified when closing previous UIFrame)
		self.releasePause()	//release pause (it was paused when adjusting parameters)
		self.LookUpElement("PlayState").DLGValue("true")  //right state of Play button
		self.LookUpElement("ResetState").DLGValue("true") //forbidden to reset		
		}	
	}

//prepare all needed to display Timer
void initDisplay(object self)
	{
	//convert days,hours,min,sec into one number in sec
	self.UpdateMaxTime()
	
	//prepare DataBank with all digits
	number w,h
	for(number i=0;i<=9;i++)
		{
		image num = self.DrawDigit(i)
		if(i==0) 
			{
			num.getsize(w,h)
//result("\n"+i+" "+w+"x"+h)
			DigitBank:= integerimage("",1,0,w,h,10)
			}

		PasteImage112(num,DigitBank[0,0,i,w,h,i+1])
		}

	//Set Global wigth, height
	Width = w
	Height = h

	//prepare deliminator
	delim := self.GraphicFromString(":",size,"",1,Bcgrd)
	delim.getsize(w,h)
result("\n" +w+"x"+h)

	//set Global deliminator wigth and calculate total width
	Between = w
	TotWidth = 4*width+Between
	if(CountDays) TotWidth += (2*Width+Between)
	if(CountSec) TotWidth += (2*Width+Between)
result("\nWidth "+Width +" Deliminator "+Between+" TotWidth "+TotWidth+" Height "+Height)

	//prepare Tableau image
	Tableau := self.DrawTableau() 
		
	//reset Tableau
	Counts = 255
	self.updateTableau(Tableau,t)		
	Counts = 255		
	}
	
//Initialization
void init(object self,number BcgrdP,string Package,string Name)
	{
	Bcgrd = BcgrdP
	
	//needed because UIFrame112 displayed through redrawer
	self.SetPackageName(Package)
	self.SetFrameName(Name) 
	
	//Load parameters
	sizeName = "font size"
	DaysName = "Target Time(day)"
	HoursName = "Target Time(hour)"	
	MinName = "Target Time(min)"
	SecName = "Target Time(sec"
	MessageName = "Message"
	CountDaysName = "Count days"
	CountSecName = "Count sec"
	
	size = self.LoadNumber112(22,sizeName)
	CountSec = self.LoadNumber112(1,CountSecName)
	CountDays = self.LoadNumber112(0,CountDaysName)
	TargetD = self.LoadNumber112(0,DaysName)
	TargetH = self.LoadNumber112(0,HoursName)
	TargetM = self.LoadNumber112(1,MinName)
	TargetS = self.LoadNumber112(0,SecName)
	Message = self.LoadString112("Message",MessageName)

	//initialize array with actual time digits
	Counts := integerImage("",1,0,8,1)
	
	//prepare to display Timer
	self.initDisplay()	
	
	//display UIFrame. Name "RedrawnUIFrame112" is standard 
	self.RedrawnUIFrame112()
	}


number AboutToCloseUIFrame112(object self, number verify)
	{
	running = 0		//thread must be stopped when Timer closed
	}


void UpdatePeriod(object self)
	{
	if(CountSec) Period = 1 +0.03
	else Period = 60 +0.03
	}

//adjustment of global parameters	
void Settings(object self)
	{	
	self.Pause()	//thread must be paused during change of display options
	
	number NumberLines = 8		//number of adjusted parameters
	
	TagGroup DaysT = DLGCreateIntegerField(TargetD,4)
	TagGroup HoursT = DLGCreateIntegerField(TargetH,4)
	TagGroup MinT = DLGCreateIntegerField(TargetM,4)
	TagGroup SecT = DLGCreateIntegerField(TargetS,4)	
	TagGroup MessageT = DLGCreateStringField(Message,20)
	TagGroup sizeT = DLGCreateIntegerField(size,4)
	TagGroup CountDaysT = DLGCreateCheckBox("",CountDays)
	TagGroup CountSecT = DLGCreateCheckBox("",CountSec)
	
	//Compose DLG tags
	TagGroup SettingList = DLGCreateBox("Settings").DLGTableLayout(1,NumberLines,1)
	//SettingsLine is UIFrame112 
	SettingList.DLGaddElement(self.SettingsLine(DaysName,DaysT).DLGAnchor("East")) 
	SettingList.DLGaddElement(self.SettingsLine(HoursName,HoursT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(MinName,MinT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(SecName,SecT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(MessageName,MessageT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(SizeName,sizeT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(CountDaysName,CountDaysT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(CountSecName,CountSecT).DLGAnchor("East"))
		
	//open dialog
	object SettingsFrame = Alloc(UIframe).init(SettingList)
	
	if(SettingsFrame.Pose())
		{	
		//SettingNumberParameter is UIFrame112
		TargetD = self.SettingNumberParameter(DaysT,DaysName) 
		TargetH = self.SettingNumberParameter(HoursT,HoursName)
		TargetM = self.SettingNumberParameter(MinT,MinName)
		TargetS = self.SettingNumberParameter(SecT,SecName)
		CountDays = self.SettingNumberParameter(CountDaysT,CountDaysName)
			number OldCountSec = CountSec
		CountSec = self.SettingNumberParameter(CountSecT,CountSecName)
		size = self.SettingNumberParameter(SizeT,SizeName)
		//SettingStringParameter is UIFrame112
		Message = self.SettingStringParameter(MessageT,MessageName) 
		
		//update period if countSec changed
		self.UpdatePeriod()
		if((OldCountSec==0)&&(CountSec==1)) OKdialog("Timer will start track seconds in about one minute")
		//update max time
		self.UpdateMaxTime()
		
		//prepare to display Timer
		self.initDisplay()
		
		//lanch the redrawer object
		alloc(DLGredrawer112).init(self.ScriptObjectgetID()).StartThread("Go")
		}	
	}	
	
void RunTimer(object self)
	{
	Running = 1
	paused = 0
	self.UpdatePeriod()
	
	Tick0 = GetHighResTickCount()

	while(Running)
		{
		sleep(Period)
		while(paused) sleep(Period)
		
		t = CalcHighResSecondsBetween(Tick0,GetHighResTickCount()) - tP
		
//result("\n"+t)
		
		if(t<MaxTime) 
			{			
			try{
			
				self.updateTableau(Tableau,t)
				
				self.LookUpElement("Tableau").DLGGetElement(0).DLGBitmapData(Tableau)
				
				}
			catch{break;}
						}
		else
			{
			try
				{	
				GetFrameWindow(self).WindowSetViewState(0)
				//In GMS 3 DLG window cannot be minimized, thus the view state handler is invalid
				}
			catch
				{
				break;
				}
			
			image ShownMessage = self.DrawMessage()
			
			while(running&&(!SpaceDown()))
				{	
				t = CalcHighResSecondsBetween(Tick0,GetHighResTickCount())- tP			
				try{
					self.LookUpElement("Tableau").DLGGetElement(0).DLGBitmapData(ShownMessage);
					}
				catch{running=0;break;}
					
				sleep(0.5)
				beep()
				
				try{
					self.updateTableau(Tableau,t)
					self.LookUpElement("Tableau").DLGGetElement(0).DLGBitmapData(Tableau)
					}
				catch{running=0;break;}
					
				sleep(0.5)
				beep()
				}
				
			running = 0
			}
		}
		
result("\ncounting finished")		
	}


void ClickPlay(object self)
	{
	string PlayState = self.LookUpElement("PlayState").DLGGetStringValue()
//result("\nPlayState "+PlayState+"#")
	if(PlayState=="true")
		{
		if(Running)	//Timer was paused
			{
			self.releasePause()
			}
		else		//Timer was reset
			{		
			self.StartThread("RunTimer")
			self.LookUpElement("ResetState").DLGValue("false")	
			}
			
		self.LookUpElement("ResetState").DLGValue("true") //forbidden to reset			
		} 
		
	if(PlayState=="false")	
		{
		self.Pause()
//result("\nResetState "+self.LookUpElement("ResetState").DLGGetStringValue()+"#")
		self.LookUpElement("ResetState").DLGValue("false")	//may reset		
		}	
	}
	
	
void reset(object self)
	{
	string ResetState = self.LookUpElement("ResetState").DLGGetStringValue()
	
	if(ResetState=="true")
		{
		//reset
		Paused  = 0
		Running = 0
		
		sleep(period)
		self.updateTableau(Tableau,0)
		self.LookUpElement("Tableau").DLGGetElement(0).DLGBitmapData(Tableau)
		
result("\nreset")
		self.LookUpElement("ResetState").DLGValue("false") //restore pre-CLICK state
		}
	if(ResetState=="false")
		{
		result("\nnot active")	
		self.LookUpElement("ResetState").DLGValue("true") //restore pre-CLICK state
		}

	}

}

//this command safely lanch BackgroundAdapter and Timer
void createAll()
{
string lab = "_temDM-Scripts"
number Bcgrd 
if(!getPersistentNumberNote(lab+":"+"background",Bcgrd )) Bcgrd = 210
SetPersistentNumberNote(lab+":"+"background",Bcgrd )

if(ControlDown())
	{
	alloc(BackgroundAdapter112).init(lab) 
	}

getPersistentNumberNote(lab+":"+"background",Bcgrd )
string package = "_temDM-Scripts:Timer:"
string Name = "Starter"
alloc(Timer112).init(Bcgrd,Package,Name) 

}

createAll() 

